%------------------------------------------------%
%  UAV_q_1Functionvalue.m                        %
%  Evaluates the the UAV model x_dot = f(x,u)    %
%  at the given state/controll variables values. %
%  Lars Arne Grimsland, spring 2012              %
%------------------------------------------------%

function f = UAV_q_1_Functionvalue(x,u1,u2)
g=9.81;         % gravity constant
f=zeros(4,1);   % preallocating


f(1) = x(3)*cos(x(4));    % x1 - Position, North
f(2) = x(3)*sin(x(4));    % x2 - Position, east
f(3) = u1;                % x3 - UAV (vind)speed, u1 = commanded acc.
f(4) = g*tan(u2)/x(3);    % x4 - UAV heading angle, u2 = bank angle

end
