% Objective function gradient %

% Using symbolic differensiation to find gradinet
jac_obj = jacobian(objective,x);

% make shure file is empty before writing
fid = fopen(obj_jac_path, 'w');
fclose(fid);
fid = fopen(obj_jac_path, 'at');

disp(' Generalizing/writing objective function gradient')

for k=0:(segments-1)
    for i = 1:ovn*2 % ovn*2 = number of opt. vars in a bolck/segment
        s           = jac_obj(i);
        pos         = i-1+k*ovn;
        index       = num2str(pos);
        stringen    = ccode(s);
        modifiedStr = strrep(stringen, 't0 = ', ' '); % removing name
        % correcting variable names/indexes to C-style.
        % All variable indices increases with 'ovn' for each block
        
        % IMPORTANT! All variables in objective must be generalized! %
        newVar1= strcat( 'x[11+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x11', newVar1 );
        newVar2= strcat( 'x[12+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x12', newVar2 );
        newVar3= strcat( 'x[13+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x13', newVar3 );
        newVar4= strcat( 'x[14+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x14', newVar4 );
        newVar5= strcat( 'x[15+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x15', newVar5 );
        newVar5= strcat( 'x[16+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x16', newVar5 );
        newVar5= strcat( 'x[17+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x17', newVar5 );
        newVar5= strcat( 'x[18+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x18', newVar5 );
        newVar5= strcat( 'x[19+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x19', newVar5 );
        newVar5= strcat( 'x[20+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x20', newVar5 );
        newVar5= strcat( 'x[21+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x21', newVar5 );
        newVar5= strcat( 'x[22+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x22', newVar5 );
        newVar5= strcat( 'x[23+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x23', newVar5 );
        newVar5= strcat( 'x[24+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x24', newVar5 );
        newVar5= strcat( 'x[25+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x25', newVar5 );
        newVar5= strcat( 'x[26+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x26', newVar5 );
        newVar5= strcat( 'x[27+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x27', newVar5 );
        newVar5= strcat( 'x[28+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x28', newVar5 );
        newVar5= strcat( 'x[29+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x29', newVar5 ); 
        
        if k==0     % First block
            val_index = int2str(i-1);
            modifiedStr = strcat( 'grad_f[',val_index,'] = ' , modifiedStr, ' \n' );
        elseif i<=ovn
            % Overlap; +=
            val_index = int2str(i-1 + k*ovn);
            modifiedStr = strcat( 'grad_f[',val_index,'] += ' , modifiedStr, ' \n' );
        else        % Append; =
            val_index = int2str(i-1 + k*ovn);
            modifiedStr = strcat( 'grad_f[',val_index,'] = ' , modifiedStr, ' \n' );
        end
        
        fprintf(fid, modifiedStr);
    end
    fprintf(fid, '\n  /* --- Next Block --- */ \n');
end

fclose(fid);