%% -  Writing constraints to file (as C code)-  %%
disp('Translating to C code, writing to file')

% open file to write to. NB! workaround to assure empty file
fid = fopen(g_ccode_path,'w');
fclose(fid);
fid = fopen(g_ccode_path, 'at');


for i = 1:svn % svn : system variables pr node = size(g)
    constraint=g(i);
    index = int2str(i-1);       % translate to c-style index
    g_c = ccode(constraint);    % port constraint to c-code string
    g_i_expression = strrep(g_c, 't0 = ', ' ');
    g_line= strcat( 'g[',index,'+',svn_str,'*i] = ', g_i_expression,'\n' );
    fprintf(fid, g_line);
end

% NOTE!! Only defect from first segment/block is written to file!
% For loop in C app where including writes all defects/constr.
% In IPOPT variables: x[n]->x[n+i*ovn], and block is looped "segment" times

fclose(fid);